<?php


class RoomtodoAdmin {

    public static function init()  
    {
        add_action( 'admin_action_roomtodo_options', ['RoomtodoAdmin', 'on_submit'] );
        add_action( 'admin_menu', ['RoomtodoAdmin', 'on_show_menu']);
    }

    public static function on_show_menu() {
        add_options_page( 'Roomtodo Settings', 'Roomtodo', 'administrator', 'roomtodo_options', ['RoomtodoAdmin', 'on_show_page']);
    }
    public static function on_submit() {
        check_admin_referer( 'roomtodo_action', 'roomtodo_nonce' );

	$m = array(); 
	preg_match("#[a-f0-9]{32}\s*$#i",$_POST['site_key'],$m);
        $site_key = trim($m[0]);

	$login = sanitize_text_field($_POST['merchant_login']);
	$password = sanitize_text_field($_POST['merchant_password']);
        update_option('roomtodo_merchant_login', $login);
        update_option('roomtodo_merchant_password', $password);
        update_option('roomtodo_site_key', $site_key);

	delete_metadata('user', 0, 'roomtodo_token', null, true); //  true = delete for all users
        update_option('roomtodo_merchant_token', '');

        wp_redirect( add_query_arg('msg',1, wp_get_referer()) );
        exit();
    }

    public static function on_show_page() {
?>

    <?php if (1 == $_GET['msg']) { ?>
    <br><br><div class="notice notice-success is-dismissible" style="margin-left:2px;">
        <p><?php echo 'Settings saved.'; ?></p>
    </div>
    <?php } ?>
    <h1>Roomtodo settings</h1>
    <form method="POST" action="<?php echo admin_url( 'admin.php' ); ?>">
        <?php wp_nonce_field( 'roomtodo_action','roomtodo_nonce' ); ?>

	<table class="form-table"><tr>
        <th scope="row"><label for="merchant_login">Merchant E-mail:</label></th>
        <td><input class="regular-text" type="text" name="merchant_login" id="merchant_login" value="<?php echo esc_attr(get_option('roomtodo_merchant_login'));?>" />
	</td></tr><tr>

        <th scope="row"><label for="merchant_password">Merchant Password:</label></th>
        <td><input class="regular-text" type="password" name="merchant_password" id="merchant_password" value="<?php echo esc_attr(get_option('roomtodo_merchant_password'));?>" />
	</td></tr><tr>

        <th scope="row"><label for="site_key">Site Key:</label></th>
        <td><input class="regular-text" type="text" name="site_key" id="site_key" value="<?php echo esc_attr(get_option('roomtodo_site_key'));?>" />
	<p class="description" id="tagline-description">Use full url like "https://roomtodo.com/planner?site_key=47e9ec...7a87c"<br>or just "47e9ec...7a87c".</p>
	</td></tr></table>

	<div class="notice notice-info notice-title notice-large"><p>To add Roomtodo planner to any page, use shortcode <kbd>[roomtodo]</kbd> or <kbd>[roomtodo class="..." style="..."]</kbd>.<br>For example:<br><kbd>[roomtodo style="width:100%; height:650px"]</kbd></p></div><br><br>

        <input type="hidden" name="action" value="roomtodo_options" />
        <input type="submit" class="button button-primary" value="Save changes" />
    </form>

<?php
    }

}// Class 