<?php

/*
function wlog($arg1=null) {
  $str = date('Y-m-d H:i:s');
  foreach(func_get_args() as $arg) $str .= ' ' . ( is_array($arg) || is_object($arg) ? var_export($arg, true) : $arg );
  fwrite(fopen(__DIR__. "/debug.log", 'a'), "$str\n");
}
*/


class RoomtodoAPI
{

    private static $api_endpoint = 'https://roomtodo.com/api/merchant/';


    public static function init()
    {
        add_shortcode('roomtodo', ['RoomtodoAPI', 'do_shortcode']);
//	add_action('wp_logout', ['RoomtodoAPI', 'clear_user_meta']);
    }

    public static function clear_user_meta($user_id) {
        update_user_meta($user_id, 'roomtodo_token', '');
    }

    public static function do_shortcode( $attrs, $content, $tag='roomtodo') 
    {

	$user_token = '';
	$site_key = get_option('roomtodo_site_key');
	$user = wp_get_current_user();
	if($user->exists()) {
	   $exp = (int) get_user_meta($user->ID, 'roomtodo_expiry', true);
	   $user_token = get_user_meta($user->ID, 'roomtodo_token', true);
	   
	   if (!$user_token || $exp < time()) {	// refresh token in meta
	      $user_token = self::generate_token($user->user_email);
	      update_user_meta($user->ID, 'roomtodo_token', $user_token);
	      update_user_meta($user->ID, 'roomtodo_expiry', strtotime("+6 days"));
	   }
	}
	// render '<iframe src...'
	extract($attrs); // $class and $style
	ob_start();
	include __DIR__ . "/iframe.php";
	$ret = ob_get_clean();
	return $ret;
    }

    // logins user by $email in roomtodo API and returns $user_token
    public static function generate_token($email) {

        $token = self::loginByMerchant();
        if (!$token) return;

        $user_token = self::loginUser($email, $token);
        if ($user_token == '-1') {
             $r2duser_id = self::registerUser($email, $token);
             $user_token = self::loginUser($email, $token);
        }
        return $user_token;
    }

    public static function loginUser($username, $token)
    {
        $user_token = '';
        $url = self::$api_endpoint . 'user_login';
        $merchant_data = [
            'login' => $username,
        ];

        $params = array(
            'body' => wp_json_encode($merchant_data),
            'timeout' => 60,
            'sslverify' => FALSE,
            'headers' => array(
                'x-token' => $token,
                'Content-Type' => 'application/json;charset=' . get_bloginfo('charset'),
            ),
        );
	
        $response = wp_remote_post( $url, $params );
        if(empty($response['body'])) return '';

        $resp_data = json_decode($response['body'], true);
        if ($resp_data['status'] == 'ok') {
                $user_token = $resp_data['data']['token'];
        } else {
            if($resp_data['error'] == 'user_not_found'){
                    $user_token = -1;
            }
        }
        return $user_token;
    }

    public static function registerUser($username, $token)
    {
        $user_id = 0;
        $url = self::$api_endpoint . 'user_register';
        $merchant_data = [
            'login' => $username,
            'name' => $username
        ];

        $params = array(
            'body' => wp_json_encode($merchant_data),
            'timeout' => 60,
            'sslverify' => FALSE,
            'headers' => array(
                'x-token' => $token,
                'Content-Type' => 'application/json;charset=' . get_bloginfo('charset'),
            ),
        );

        $response = wp_remote_post( $url, $params );
	if (empty($response['body'])) return 0;
 
        $resp_data = json_decode($response['body'], true);
        if($resp_data['status'] == 'ok'){
                $user_id = $resp_data['data']['token'];
        } else{
                if($resp_data['error'] == 'user_already_exists'){
                    $user_id = -1;
                }
        }
        return $user_id;
    }

    public static function loginByMerchant($force = false)
    {
        $token = get_option('roomtodo_merchant_token');
        $exp = (int) get_option('roomtodo_merchant_expiry');

        if ($token && !$force && $exp > time()) {
            return $token;
        }

        $url = self::$api_endpoint . 'merchant_login';
        $merchant_data = [
            'login' => get_option('roomtodo_merchant_login'),
            'password' => get_option('roomtodo_merchant_password'),
        ];

        $params = array(
            'body'    => wp_json_encode( $merchant_data ),
            'timeout' => 60,
            'sslverify' => FALSE,
            'headers' => array(
                'Content-Type' => 'application/json;charset=' . get_bloginfo( 'charset' ),
            ),
        );

        $response = wp_remote_post( $url, $params );

	$token = '';
        if (empty($response['body'])) return;

        $resp_data = json_decode($response['body'], true);
        if($resp_data['status'] == 'ok'){
            $token = $resp_data['data']['token'];
        }

        if (!$token) return;
        update_option('roomtodo_merchant_token', $token);
        update_option('roomtodo_merchant_expiry', strtotime("+6 days"));
        return $token;
    }

}
