<?php
 // template for showing [roomtodo] shortcode
 // params:  $site_key, $user_token, $style, $class

$site_key = sanitize_key($site_key);
if ($user_token) $user_token = sanitize_key($user_token);
if ($style) $style = safecss_filter_attr( $style );
if ($class) $class = join(' ', array_filter(array_map('sanitize_html_class', explode(' ', $class))));

if (!$class && !$style) $style="width: 800px; height: 600px;";
?>
<iframe frameborder="0" id="iframe<?php echo $site_key; ?>" 
  src="https://roomtodo.com/planner?site_key=<?php echo $site_key?>" 
  <?php if ($style) echo 'style="' . $style . '"';?>
  <?php if ($class) echo 'class="' . $class . '"';?>
></iframe>
<script>
    window.addEventListener('message', messageListener);
    function messageListener(e) {
        try {
            var dataObj = JSON.parse(e.data);
            if (dataObj.action == 'program_ready') {
                const parsedHash = new URLSearchParams(window.location.hash.substr(1));
                if (parsedHash.has('project')) {
                    document.getElementById('iframe<?php echo $site_key;?>').contentWindow.postMessage(`{"action": "load_project", "hash": "${parsedHash.get('project')}"}`, '*');
                }
		document.getElementById('iframe<?php echo $site_key;?>').contentWindow.postMessage(`{"action": "set_token", "token": "<?php echo $user_token ?: "-1";?>"}`, '*');
            }
        } catch ( error ) {}
    }

</script>